#include <iostream>
#include <cmath>
#include <ctime>
#include <cstring>
using namespace std;
#include "vector.hpp"
#include "grid.hpp"
#include "grid2d.hpp"
#include "grid3d.hpp"
#include "laplace2d.hpp"
#include "laplace3d.hpp"
#include "laplace_vary_3d.hpp"
#include "multigrid.hpp"
#include "mgprocs.hpp"

#define DEFAULT_LEVELS 3

int main(const int argc, const char* argv[])
{
// CtrlRec simple = {30,1,1,1, bilinear,bilinear,ADI_forw,ADI_backw, false, false, 1e-06};
//  CtrlRec simple = {30,1,1,1, bilinear,bilinear,omega_Jacobi,omega_Jacobi, false, false, 1e-06};
// CtrlRec simple = {30,1,1,1, bilinear,bilinear,GS_forw,GS_backw, false, false, 1e-04};
CtrlRec simple = {15,1,2,2, linear,linear,GS_forw,GS_backw, false, false, 1e-04};
// CtrlRec simple = {15,1,2,2, bilinear,bilinear,omega_Jacobi,omega_Jacobi, false, false, 1e-04};

  unsigned int levels;
           int iter;
  unsigned long nfine, nx;
	 double *u, *f, *cc;
	 double norm, rate;
	 double tstart, tdiff;
       bool bcc=!true;

  levels = (argc > 1) ? atoi(argv[1]) : DEFAULT_LEVELS;
  if (levels<=0) exit (-1);

// ####################################################################
//	Test fr NonEqui3D
// ####################################################################
//    const int NN = 5;
// //   const double xx[NN] = {0,1,2,3,4};
// //   const double xx[NN] = {0.0, 0.05, 0.15, 0.25, 0.30};
//    const double xx[NN] = {0.0, 0.05, 0.15, 0.35, 0.65};
// //   const double xx[NN] = {0.0, 0.05, 0.15, 0.35, 0.65, 1.0};
//    double *uh,*UH,*FH,*DH;
//
// //   const NonEqui3D mygrid(NN,xx);
// //   NonEqui3D myfine,newco;
//    const LaplaceNonEqui3D mygrid(NN,xx);
//    LaplaceNonEqui3D myfine,newco;
//
//    mygrid.Refine(myfine);
//
//    mygrid.NewGridVector(UH); mygrid.NewGridVector(FH); mygrid.NewGridVector(DH);
//    myfine.NewGridVector(uh);
//    VDcopyC(mygrid.VectorLength(),UH,1.0);
//    VDcopyC(myfine.VectorLength(),uh,1.0);

//   mygrid.SetBoundaryZero(UH);
//   myfine.SetBoundaryZero(uh);
//   myfine.Restrict(uh,UH);
//   myfine.Interpolate(uh,UH);
//   PrintVector(myfine.VectorLength(),uh);

/*
 *    VDcopyC(mygrid.VectorLength(),FH,0.0);
 *    mygrid.Defect(FH,UH,DH);
 *    PrintVector(mygrid.VectorLength(),DH);
 *
 *    myfine.NewGridVector(uh);
 */

//    cout << endl << "=========  Check Interpolation()  ========" << endl;
//    VDcopyC(mygrid.VectorLength(),UH,1.0);
//    myfine.Interpolate(uh,UH);
//    PrintVector(myfine.VectorLength(),uh);

//    cout << endl << "=========  Check Restrict()  ========" << endl;
//    VDcopyC(myfine.VectorLength(),uh,1.0);
//    VDcopyC(mygrid.VectorLength(),UH,0.0);
//    myfine.Restrict(uh,UH);
//    PrintVector(mygrid.VectorLength(),UH);

//   myfine.Coarse(newco);


// ####################################################################

#define TEST_LaplaceEqui2D
// #define TEST_LaplaceEqui2DNeumann
// #define TEST_LaplaceNonEqui2D
// #define TEST_LaplaceEqui3D
// #define TEST_LaplaceEqui3DNeumann
// #define TEST_LaplaceNonEqui3D
// #define TEST_LaplaceVaryNonEqui3D

//   Grid parameters for non-equidistant grid
  const int NODES = 3;
  const double xnodes[NODES] = {0.0, 0.5, 1.0};
  const int NNY = 5;
//  const double yy[NNY] = {0.0, 0.15, 0.2, 0.3, 0.4};
  const double yy[NNY] = {0.0, 0.1, 0.2, 0.3, 0.4};

#if (defined TEST_LaplaceNonEqui3D)
 cout << " ++++++++++   LaplaceNonEqui3D   +++++++++++++++" << endl;
//				Define coarse grid
 const LaplaceNonEqui3D coarse(NODES,xnodes,true);
//   const LaplaceNonEqui3D coarse(NNY,yy,true);

//	 			Construct grid hierachy, mg-control,mg-vectors
  MultiGrid<LaplaceNonEqui3D> MG(simple,levels,coarse);

//				Have access to fine grid information
  const LaplaceNonEqui3D & fine = MG.GetFineGrid();

#elif (defined TEST_LaplaceVaryNonEqui3D)
 bcc = true;
 cout << " ++++++++++   LaplaceVaryNonEqui3D   +++++++++++++++" << endl;
 const LaplaceVaryNonEqui3D coarse(NODES,xnodes,true);
//   const LaplaceVaryNonEqui3D coarse(NNY,yy,true);

//	 			Construct grid hierachy, mg-control,mg-vectors
  MultiGrid<LaplaceVaryNonEqui3D> MG(simple,levels,coarse);
//   MultiGrid<Grid3D> MG(simple,levels,coarse);

//				Have access to fine grid information
  const LaplaceVaryNonEqui3D & fine = MG.GetFineGrid();

#elif (defined TEST_LaplaceNonEqui2D)
 cout << " ++++++++++   LaplaceNonEqui2D   +++++++++++++++" << endl;
//				Define coarse grid
  const LaplaceNonEqui2D coarse(NODES,xnodes,NODES,ynodes,true);
//  const LaplaceNonEqui2D coarse(NODES,xnodes,true);
//  const LaplaceNonEqui2D coarse(NNY,yy,true);

//	 			Construct grid hierachy, mg-control,mg-vectors
  MultiGrid<LaplaceNonEqui2D> MG(simple,levels,coarse);

//				Have access to fine grid information
  const LaplaceNonEqui2D & fine = MG.GetFineGrid();

#elif (defined TEST_LaplaceEqui2D)

 cout << " ++++++++++   LaplaceEqui2D   +++++++++++++++" << endl;
//				Define coarse grid
  const DiagLaplaceEqui2D coarse(2,2,true);
//				Construct grid hierachy, mg-control,mg-vectors
  MultiGrid<DiagLaplaceEqui2D> MG(simple,levels,coarse,levels);
//   MG.SetCalcLevel(levels-1);

//				Have access to fine grid information
  const DiagLaplaceEqui2D & fine = MG.GetFineGrid();

  #elif (defined TEST_LaplaceEqui2DNeumann)

 cout << " ++++++++++   LaplaceEqui2DNeumann   +++++++++++++++" << endl;
//				Define coarse grid
  const DiagLaplaceEqui2DNeumann coarse(2,2,true);
//				Construct grid hierachy, mg-control,mg-vectors
  MultiGrid<DiagLaplaceEqui2DNeumann> MG(simple,levels,coarse);
//   MG.SetCalcLevel(levels-1);

//				Have access to fine grid information
  const DiagLaplaceEqui2DNeumann & fine = MG.GetFineGrid();

#elif (defined TEST_LaplaceEqui3D)
 cout << " ++++++++++   LaplaceEqui3D   +++++++++++++++" << endl;
//				Define coarse grid
  const DiagLaplaceEqui3D coarse(2,2,2,true);
//				Construct grid hierachy, mg-control,mg-vectors
  MultiGrid<DiagLaplaceEqui3D> MG(simple,levels,coarse);

//				Have access to fine grid information
  const DiagLaplaceEqui3D & fine = MG.GetFineGrid();

#elif (defined TEST_LaplaceEqui3DNeumann)
 cout << " ++++++++++   LaplaceEqui3DNeumann   +++++++++++++++" << endl;
//				Define coarse grid
  const DiagLaplaceEqui3DNeumann coarse(2,2,2,true);
//				Construct grid hierachy, mg-control,mg-vectors
  MultiGrid<DiagLaplaceEqui3DNeumann> MG(simple,levels,coarse);

//				Have access to fine grid information
  const DiagLaplaceEqui3DNeumann & fine = MG.GetFineGrid();

#else
  cout << endl << "No class available" << endl; exit(-1);
#endif

  nfine = fine.VectorLength();
  nx    = fine.GetIntX();
  cout << "Vektor: "<< nfine << endl;

  u  = new double[nfine];
  f  = new double[nfine];
  if (bcc)
   {
/*     cout << "AAAAAAAAAAAAAAAAAAA" << endl;*/
     cc = new double[nfine];
     VDcopyC(nfine, cc,1.0);			// cc is used
//     VDcopyC(nfine, cc,0);			// cc is used
     MG.AddDiagTerm(cc);
   }

  VDcopyC(nfine, f, 1.5*nx*nx);
  fine.SetBoundaryZero(f);

  tstart = clock();

 {
    const int TEST_MAX = 3;
	  int    test;
    double tact, tges = 0.0, tmax = 0.0, tmin = 1e25;

    cout << endl;
    for (test=1; test<=TEST_MAX; test++)
    {
      tact = clock();
///					Call Multigrid solver
      MG.Solve(u, f, iter, norm);

      tact  = clock() - tact;
      tges += tact;
      if (tact>tmax) tmax = tact;
      if (tact<tmin) tmin = tact;
      cout << " test cycle  " << test << endl;
    }

     cout << endl << "Times" << endl;
     cout << "Min : " << tmin/CLOCKS_PER_SEC << " sec" << endl;
     cout << "Max : " << tmax/CLOCKS_PER_SEC << " sec" << endl;
     cout << "Aver: " << tges/TEST_MAX/CLOCKS_PER_SEC << " sec" << endl;
  }

  tdiff = (clock()-tstart)/CLOCKS_PER_SEC;

  rate = pow(norm,1.0/iter);

  cout << endl << levels << " Gitter brauchten " << iter
       << " Iterationen; Rate = " << rate << endl;
  cout << "in " << tdiff <<  " sec" << endl;
  cout << " Error: " << norm << endl;


//    fine.VectorToFile(u,"u.dat");

  if (bcc)  delete []cc;
  delete []f; delete []u;

  return 0;
}

