#ifndef FILE_EVPROCS
#define FILE_EVPPROVS

void PresetAB(const unsigned int p, double A[], double B[]);

void PrintB(const unsigned int p, const double B[]);
void PrintEValues(const unsigned int p, const double delta[]);
void PrintArrayLevel(const unsigned int level,const  unsigned int n, 
							const double x[]);

void SolveEVP(unsigned int p, double* A,  double* B, double* delta, double* Q, 
	double* aux, unsigned int aux_l);

void SolveEVP_2(const unsigned int p, double A[], double B[], double delta[], 
	double aux[], const unsigned int aux_l, int& info);

//	the following routines have to be implemented for the special problem

// 3D

void SetEigenmode3D(const unsigned int imode, const unsigned int jmode, const unsigned int kmode, 
		const unsigned int n, double x[]);
void SetFunction3D(const unsigned int ip, const unsigned int n, double x[]);
void InitVectors3D(const unsigned int p, const unsigned int nx, double X[]);
void Init3D_c(const unsigned int nx, double X[]);
void PrintEFunctions3D(const unsigned int p, const unsigned int nx,
						 const double X[]);

// 2D

void InitVectors2D(const unsigned int p, const unsigned int nx, double X[]);

#endif
